package struts.kenkyu03b.action;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.MapHandler;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import struts.kenkyu03b.form.ProductEditForm;

public class ProductEditAction extends BaseAction {
	/**
	 * ҏWʕ\(cmd=edit)
	 */
	public ActionForward edit(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		//ꗗʂőIҏWΏ(ActionForm)
		ProductEditForm editForm = (ProductEditForm)form;
		
		//DBΏۂ̃R[hāAupdateFormɊi[
		QueryRunner run = new QueryRunner();
		ResultSetHandler h = new MapHandler();
		Map product = (Map)run.query(
				getConn(request),
				"select * from products where pcode = ?", 
				editForm.getPcode(), h);
		
		//MapupdateForm
		BeanUtils.copyProperties(editForm, product);
		
		//ҏWʂ̑Jڐ𔻕ʂtO
		request.setAttribute("isUpdate", Boolean.TRUE);
		
		return mapping.findForward("edit");
		
	}
	/**
	 * VK쐬ʕ\(cmd=editnew)
	 */
	public ActionForward editnew(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		//ҏWʂ̑Jڐ𔻕ʂtO
		request.setAttribute("isUpdate", Boolean.FALSE);
		return mapping.findForward("edit");
		
	}
	
	/**
	 * XV(cmd=update)
	 */
	public ActionForward update(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		//ҏWʂŕҏWB
		ProductEditForm editForm = (ProductEditForm)form;
		
		QueryRunner run = new QueryRunner();
		//DBXV
		run.update(
				getConn(request),
				"update Products set"
				+ " pname = ?,"
				+ " price = ?,"
				+ " date_available = ?"
				+ " where pcode = ?",
				new Object[]{
					editForm.getPname(),
					editForm.getPrice(),
					editForm.getDate_available(),
					editForm.getPcode(),
				});
		
		return mapping.findForward("success");
	}
	/**
	 * o^(cmd=insert)
	 */
	public ActionForward insert(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		QueryRunner run = new QueryRunner();
		
		//ꗗʂőIҏWΏ(ActionForm)
		ProductEditForm editForm = (ProductEditForm)form;
		
		//DBVKo^
		run.update(
				getConn(request),
				"insert into Products(pcode, pname, price, date_available)"
				+ " values("
				+ " (select max(pcode) + 1 from Products),"		//̍̔ԏ
				+ " ?,"
				+ " ?,"
				+ " ?)",
				new Object[]{
					editForm.getPname(),
					editForm.getPrice(),
					editForm.getDate_available(),
				});
		
		return mapping.findForward("success");
	}
	
	/**
	 * 폜(cmd=delete)
	 */
	public ActionForward delete(
			ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		QueryRunner run = new QueryRunner();
		
		//ꗗʂőIҏWΏ(ActionForm)
		ProductEditForm editForm = (ProductEditForm)form;
		
		//DBVKo^
		run.update(
				getConn(request),
				"delete from Products where pcode = ?",
				editForm.getPcode()
				);
		
		return mapping.findForward("success");
	}	
}
